Subject: Re: Tc bug (kernel crash) more info

From: Badalian Vyacheslav <[email-masked]>
Date: Mon, 03 Sep 2007 12:05:45 +0400

> Your errors trigger in rbtree, which does indexing for HTB, but since
> it's something quite rare I think there is a very small probability
> that it's caused by HTB class/level handling (but it's possible, too),
> but more probable (to me) these indexes are corrupted by something e.g.
> like accessing them without proper locking.
>
> Below I attach a patch for testing: it adds some lock debugging (plus
> one place: htb_put is locked). There is mainly checking of locks
> needed for writing to rbtree, but it doesn't check all readings yet,
> so there will be still something to check if this patch doesn't help
> to find anything.
>
> It should be applied to 2.6.23-rc4, but if you prefer 2.6.22.5 version
> let me know (BTW, I hope you let us know if you have to apply any
> other patches/changes to these kernels...).
>
>   
Ok... i was apply patch and see that its say... thanks...
Maybe you see bug 2 (wrong level calculation) and 3 (class not leaf but 
have qdisc) at
http://bugzilla.kernel.org/show_bug.cgi?id=8971